py::class_<Manipulator_DOF>(m, "Manipulator_DOF")
    .def(py::init<const gafro::System<double>&, const std::string&>())
    .def_property_readonly_static("dof", [](py::object) { return DOF; })
    .def("getSystem", &Manipulator_DOF::getSystem, py::return_value_policy::reference)
    .def("getLink", &Manipulator_DOF::getLink)
    .def("getJoint", &Manipulator_DOF::getJoint)
    .def("getRandomConfiguration", &Manipulator_DOF::getRandomConfiguration)
    .def("getEEKinematicChain", &Manipulator_DOF::getEEKinematicChain)
    .def("getEEMotor", &Manipulator_DOF::getEEMotor)
    .def("getEEAnalyticJacobian", &Manipulator_DOF::getEEAnalyticJacobian)
    .def("getEEGeometricJacobian", &Manipulator_DOF::getEEGeometricJacobian)
    .def("getEEFrameJacobian", &Manipulator_DOF::getEEFrameJacobian)
    .def("getJointTorques", &Manipulator_DOF::getJointTorques, py::arg("position"), py::arg("velocity"), py::arg("acceleration"), py::arg("gravity") = 9.81, py::arg("ee_wrench") = Wrench::Zero())
    .def("getJointAccelerations", &Manipulator_DOF::getJointAccelerations);
